.386
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include shell32.inc
includelib shell32.lib

;**********************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;**********************************************************************************************************

IDI_ICON    equ 100

WM_TRAY     equ WM_USER+120
IDI_TRAY    equ 245

MONITOR_ON  equ -1
MONITOR_LOW equ 1
MONITOR_OFF equ 2

;**********************************************************************************************************

.data
AppName     db "Moff",0
AppTip      db "Moff - left-click to activate; right to close.",0

.data?
hInstance   HINSTANCE   ?
hWnd        HWND        ?
iconData    NOTIFYICONDATA <?>

.code
start:
    invoke FindWindow, ADDR AppName,NULL
    .IF (eax==NULL)
        invoke GetModuleHandle, NULL
        mov hInstance,eax
        invoke WinMain
    .ENDIF
    invoke ExitProcess, eax

;** App window stuff **************************************************************************************
WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    mov wc.cbSize,SIZEOF wc
    mov wc.style,CS_HREDRAW or CS_VREDRAW
    mov wc.lpfnWndProc,OFFSET WndProc
    mov wc.cbClsExtra,NULL
    mov wc.cbWndExtra,NULL
    mov eax,hInstance
    mov wc.hInstance,eax
    mov wc.hbrBackground,COLOR_WINDOW+1
    mov wc.lpszMenuName,NULL
    mov wc.lpszClassName,OFFSET AppName
    invoke LoadIcon, hInstance,IDI_ICON
    mov wc.hIcon,eax
    mov wc.hIconSm,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov wc.hCursor,eax
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx, NULL,ADDR AppName,ADDR AppName,NULL,0,0,0,0,NULL,NULL,hInstance,NULL
    .IF (eax)
        mov hWnd,eax
        ;invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        ;invoke UpdateWindow, hWnd
        .WHILE TRUE
            invoke GetMessage, ADDR msg,NULL,0,0
            .BREAK .IF(!eax)
            invoke TranslateMessage, ADDR msg
            invoke DispatchMessage, ADDR msg
        .ENDW
        mov eax,msg.wParam
    .ENDIF
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov eax,uMsg
;;- WM_TRAY -----------------------------------------------------------------------------------------
    .IF (eax==WM_TRAY)
        .IF (wParam==IDI_TRAY)
            .IF (lParam==WM_LBUTTONUP)                      ;left button = monitor standby
                invoke Sleep, 500 ;tolerate mouse jerk
                invoke SendMessage, hWnd,WM_SYSCOMMAND,SC_MONITORPOWER,MONITOR_OFF
            .ELSEIF (lParam==WM_RBUTTONUP)                  ;right button = close
                invoke SendMessage, hwnd,WM_CLOSE,NULL,NULL
            .ENDIF
        .ENDIF
;;- WM_CREATE ---------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        push edi
        lea edi,iconData
        assume edi:ptr NOTIFYICONDATA
        mov eax,hwnd
        mov [edi].cbSize,SIZEOF NOTIFYICONDATA
        mov [edi].hwnd,eax
        mov [edi].uID,IDI_TRAY
        mov [edi].uFlags,NIF_ICON or NIF_MESSAGE or NIF_TIP
        mov [edi].uCallbackMessage,WM_TRAY
        invoke LoadIcon, hInstance,IDI_ICON
        mov [edi].hIcon,eax
        invoke lstrcpy, ADDR [edi].szTip,ADDR AppTip
        invoke Shell_NotifyIcon,NIM_ADD,edi
        assume edi:nothing
        pop edi
;;- WM_DESTROY --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke Shell_NotifyIcon,NIM_DELETE,ADDR iconData
        invoke PostQuitMessage, NULL
;-- default -----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

end start
